//
//  Crawler.h
//  CrawlSpace
//
//  Created by David Finucane on 11/8/05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "RandomPeople.h"
#import "FilterController.h"
#import "Person.h"

@interface Crawler : NSObject
{
  id delegate;
  NSMutableArray*seeds;
  NSMutableSet*seen;
  NSMutableArray*pending;
  NSMutableArray*exploring;
  NSMutableArray*people;
  
  NSTimer*timer;
  int viewPos;
  int imageNo;
  NSThread*thread;
  BOOL shouldExit;
  BOOL gettingMoreSeeds;
  BOOL gettingNames;
  int gettingImages;
  BOOL exploringNewPerson;
  int errorCount;
  int imageCount;
  int discardCount;
  int infoErrorCount,friendErrorCount;
  FilterController*filterController;
  BOOL seedFromName;
  BOOL seedFromSearch;
  BOOL seedFromPage;
  BOOL seedFromBrowse;
  NSString*nameString;
  NSString*postCode;
  NSString*postCodeType;
  BOOL gettingInfo;
  BOOL gettingPages;
  int myId;
  int maxId;
  int verge;
  int searchType;
  NSString*lastUsername;
  NSString*lastPassword;
  NSLock*crawlerLock;
}

- (id) initWithDelegate:(id)aDelegate filterController:(FilterController*)aFilterController;
- (BOOL) loginWithUsername: (NSString*) username password:(NSString*)password;
- (void) service:(NSTimer*)timer;
- (BOOL) startWithStartType:(int)startType startString:(NSString*) startString cacheSize:(int)cacheSize postCodeType:(NSString*)postCodeType postCode:(NSString*)postCode;
- (void) stop;
- (void) cancel;
- (NSImage*) forward:(int*)anId;
- (NSImage*) back:(int*)anId;
- (NSImage*) fastForward: (int*)anId;
- (NSImage*) fastBack: (int*)anId;
- (void) randomPeopleDone:(RandomPeople*) people withError:(NSError*)error;
- (void) gotInfo: (Person*)person withError:(NSError*)error;
- (void) gotFriends: (Person*)person withError:(NSError*)error;
- (void) gotImages: (Person*)person withError:(NSError*)error;
- (NSString*)getCurrentUrl;
- (BOOL)getCurrentId:(int*)anId name:(NSString**)name;
- (void) kill;
- (BOOL) sendFriendRequest:(int*)anId name:(NSString**)name;
- (int) maxId;
- (void) lockCrawlerLock;
- (void) unlockCrawlerLock;
@end

@interface NSObject (CrawlerDelegate)

- (void) setErrorCount:(int) errorCount imageCount:(int)imageCount pendingCount:(int)pendingCount matchCount:(int)matchCount discardCount:(int)discardCount;
- (void) setStatusString:(NSString*) string;
- (void) setName:(NSString*)name male:(BOOL)male anId:(int)anId age:(int)age cityState:(NSString*)cityState country:(NSString*)country;
- (void) setFastBack:(BOOL)fastBack back:(BOOL)back forward:(BOOL)forward fastForward:(BOOL)fastForward kill:(BOOL)kill mail:(BOOL)mail go:(BOOL)go;
 
@end
