//
//  FilterController.h
//  CrawlSpace
//
//  Created by David Finucane on 11/17/05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#define FilterController_BOTH 0
#define FilterController_MALE 1
#define FilterController_FEMALE 2

#define FilterController_MY_ID 0
#define FilterController_RANDOM_ID 1
#define FilterController_ID 2
#define FilterController_PAGE 3
#define FilterController_NAME 4
#define FilterController_DISPLAY_NAME 5
#define FilterController_EMAIL 6
#define FilterController_SEARCH 7
#define FilterController_BROWSE 8

extern NSString*CrawlSpaceMinAgeKey;
extern NSString*CrawlSpaceMaxAgeKey;
extern NSString*CrawlSpaceSexKey;
extern NSString*CrawlSpaceStartKey;
extern NSString*CrawlSpacePostCodeTypeKey;
extern NSString*CrawlSpacePostCodeTextKey;
extern NSString*CrawlSpaceStartStringKey;

@interface FilterController : NSWindowController
{
  IBOutlet NSPopUpButton*startPopUpButton;
  IBOutlet NSTextField*startTextField;
  IBOutlet NSMatrix*sexMatrix;
  IBOutlet NSTextField*minAgeField;
  IBOutlet NSTextField*maxAgeField;
  IBOutlet NSStepper*minAgeStepper;
  IBOutlet NSStepper*maxAgeStepper;
  IBOutlet NSPopUpButton*postCodePopUpButton;
  IBOutlet NSTextField*postCodeTextField;
  
  int sex;
  int startType;
  NSString*startString;
  int sexType;
  int minAge;
  int maxAge;
  int postCodeType;
  NSString*postCode;
  NSString*keywords;
}

- (id) init;
- (id) initWithId:(int)anId;
- (NSString*) startString;
- (int) startType;
- (int) sex;
- (int) minAge;
- (int) maxAge;
- (NSString*) postCodeType;
- (NSString*) postCode;

- (IBAction) changeStartType:(id)sender;
- (IBAction) changeStartString:(id)sender;
- (IBAction) changeSex:(id)sender;
- (IBAction) changeMinAge:(id)sender;
- (IBAction) changeMaxAge:(id)sender;
- (IBAction) stepMinAge:(id)sender;
- (IBAction) stepMaxAge:(id)sender;
- (IBAction) changePostCodeType:(id)sender;
- (IBAction) changePostCode:(id)sender;
- (void) windowWillClose:(NSNotification *)aNotification;


@end
