//
//  Person.h
//  CrawlSpace
//
//  Created by David Finucane on 11/8/05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "ImageFinder.h"
#import "InfoFinder.h"
#import "FriendFinder.h"
#import "ImageLoader.h"

@interface Person : NSObject
{
  int myId;
  int index;
  id delegate;
  NSString*name;
  BOOL male;
  BOOL band;
  int age;
  NSString*country;
  NSString*cityState;
  
  InfoFinder*infoFinder;
  FriendFinder*friendFinder;
  ImageFinder*imageFinder;
  ImageLoader*imageLoader;
  BOOL hasInfo, hasFriends, hasImages;
  BOOL gettingInfo, gettingFriends, gettingImages;
  BOOL imagesFailed;
  BOOL cancelled;
  int imageErrorCount;
}

- (id) initWithId: (int) anId delegate:(id)aDelegate;
- (void) setIndex: (int) anIndex;
- (int) index;
- (void) getInfo: (NSString*) keywords;
- (void) getFriends;
- (void) getImages;
- (void) clearFriends;
- (void) clearImages;
- (BOOL) hasInfo;
- (BOOL) band;
- (BOOL) hasFriends;
- (BOOL) hasImages;
- (BOOL) gettingInfo;
- (BOOL) gettingFriends;
- (BOOL) gettingImages;
- (void) cancel;
- (void) failImages;
- (void) setImageErrorCount:(int)count;
- (int) incrementImageErrorCount;
- (int) imageErrorCount;
- (NSArray*)getFriendArray;
- (NSArray*)getImageArray;
- (int) getNumLoadedImages;
- (int) getId;
- (NSString*)name;
- (int)age;
- (BOOL)male;
- (NSString*)cityState;
- (NSString*)country;
@end

@interface NSObject (PersonDelegate)

- (void) gotInfo: (Person*)person withError:(NSError*)error;
- (void) gotFriends: (Person*)person withError:(NSError*)error;
- (void) gotImages: (Person*)person withError:(NSError*)error;

@end
